(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('@angular/platform-browser'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-hotkeys-vnc', ['exports', '@angular/core', 'rxjs', '@angular/platform-browser', '@angular/common'], factory) :
    (global = global || self, factory(global['ngx-hotkeys-vnc'] = {}, global.ng.core, global.rxjs, global.ng.platformBrowser, global.ng.common));
}(this, (function (exports, core, rxjs, platformBrowser, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var HOTKEY_OPTIONS = new core.InjectionToken('HotkeyOptions');

    var _defaultOptions = {
        disableCheatSheet: false,
        cheatSheetTitle: 'Keyboard Shortcuts:',
        cheatSheetHotkey: 'shift.?',
        cheatSheetHotkeyDescription: 'Show / hide this help menu',
        cheatSheetCloseEsc: false,
        cheatSheetCloseEscDescription: 'Hide this help menu'
    };
    var NgxHotkeysService = /** @class */ (function () {
        function NgxHotkeysService(eventManager, config, doc) {
            var _this = this;
            this.eventManager = eventManager;
            this.config = config;
            this.registeredHotkeys = new Set();
            this.pausedHotkeys = new Set();
            this._cheatSheetToggled = new rxjs.Subject();
            this.bindingSubscriptions = new Map();
            this.document = doc;
            this.defaults = { element: this.document };
            this.configuration = __assign(__assign({}, _defaultOptions), this.config);
            if (!this.configuration.disableCheatSheet) {
                this.register({
                    combo: this.configuration.cheatSheetHotkey,
                    handler: function () {
                        _this._cheatSheetToggled.next(true);
                    },
                    description: this.configuration.cheatSheetHotkeyDescription
                });
            }
            if (this.configuration.cheatSheetCloseEsc) {
                this.register({
                    combo: 'esc',
                    handler: function () {
                        _this._cheatSheetToggled.next(false);
                    },
                    description: this.configuration.cheatSheetCloseEscDescription
                });
            }
        }
        Object.defineProperty(NgxHotkeysService.prototype, "hotkeys", {
            /**
             * Returns the registered hotkeys as array.
             * @returns all registered hotkeys
             */
            get: function () {
                return Array.from(this.registeredHotkeys);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxHotkeysService.prototype, "cheatSheetToggled", {
            /**
             * Returns an Observable stream indicating the cheatsheets visibility was toggled.
             * @returns stream indicating the cheatsheets visibility was toggled
             */
            get: function () {
                return this._cheatSheetToggled.asObservable().pipe(rxjs.share());
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxHotkeysService.prototype, "options", {
            /**
             * Returns the options used to configure this service.
             */
            get: function () {
                return this.configuration;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Registers a new hotkey/new hotkeys with it's/their handler(s).
         * @param hotkey hotkeys to listen for
         * @param unpausing flag indicating if the hotkeys should be unpaused
         */
        NgxHotkeysService.prototype.register = function (hotkey, unpausing) {
            var _this = this;
            if (unpausing === void 0) { unpausing = false; }
            var hotkeys = [].concat(hotkey);
            if (unpausing) {
                hotkeys = Array.from(this.pausedHotkeys);
            }
            hotkeys.forEach(function (h) {
                if (unpausing) {
                    _this.pausedHotkeys.delete(h);
                }
                _this.registeredHotkeys.add(h);
                _this.bindingSubscriptions.set(h.combo, _this.bindToEventManager(h)
                    .subscribe(function () {
                    h.handler();
                }));
            });
        };
        /**
         * Removes a/the registered hotkey(s).
         * @param hotkey hotkey filter
         * @param pausing flag indicating if the hotkeys should be paused
         */
        NgxHotkeysService.prototype.unregister = function (hotkey, pausing) {
            var _this = this;
            if (pausing === void 0) { pausing = false; }
            var hotkeys = [].concat(hotkey);
            hotkeys.forEach(function (h) {
                _this.registeredHotkeys.delete(h);
                if (pausing) {
                    _this.pausedHotkeys.add(h);
                }
                _this.unbindFromEventManager(h);
            });
        };
        /**
         * Returns all hotkeys matching the passed combo(s).
         * @param combo combo to match against
         * @returns all matched hotkeys
         */
        NgxHotkeysService.prototype.get = function (combo) {
            return this.hotkeys.filter(function (h) { return h.combo === combo; });
        };
        /**
         * Stops listening for the specified hotkeys.
         * @param hotkey hotkey filter
         */
        NgxHotkeysService.prototype.pause = function (hotkey) {
            if (!hotkey) {
                return this.pause(this.hotkeys);
            }
            var hotkeys = [].concat(hotkey);
            this.unregister(hotkeys, true);
        };
        /**
         * Resumes listening for the specified hotkeys.
         * @param hotkey hotkey filter
         */
        NgxHotkeysService.prototype.unpause = function (hotkey) {
            if (!hotkey) {
                return this.unpause(this.hotkeys);
            }
            var hotkeys = [].concat(hotkey);
            this.register(hotkeys, true);
        };
        /**
         * Resets all hotkeys.
         */
        NgxHotkeysService.prototype.reset = function () {
            var _this = this;
            this.registeredHotkeys.forEach(function (h) { return _this.unbindFromEventManager(h); });
            this.registeredHotkeys.clear();
            this.pausedHotkeys.clear();
        };
        NgxHotkeysService.prototype.ngOnDestroy = function () {
            this.reset();
        };
        NgxHotkeysService.prototype.bindToEventManager = function (hotkey) {
            var _this = this;
            var merged = __assign(__assign({}, this.defaults), hotkey);
            var event = "keydown." + merged.combo.replace('+', '.');
            return new rxjs.Observable(function (observer) {
                var handler = function (e) {
                    e.preventDefault();
                    observer.next(e);
                };
                var dispose = _this.eventManager.addEventListener(merged.element, event, handler);
                return function () {
                    dispose();
                };
            });
        };
        NgxHotkeysService.prototype.unbindFromEventManager = function (hotkey) {
            var merged = __assign(__assign({}, this.defaults), hotkey);
            var keySub = this.bindingSubscriptions.get(merged.combo);
            if (keySub && !keySub.closed) {
                keySub.unsubscribe();
                this.bindingSubscriptions.delete(merged.combo);
            }
        };
        NgxHotkeysService.ctorParameters = function () { return [
            { type: platformBrowser.EventManager },
            { type: undefined, decorators: [{ type: core.Inject, args: [HOTKEY_OPTIONS,] }] },
            { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] }
        ]; };
        NgxHotkeysService.ɵprov = core.ɵɵdefineInjectable({ factory: function NgxHotkeysService_Factory() { return new NgxHotkeysService(core.ɵɵinject(platformBrowser.EventManager), core.ɵɵinject(HOTKEY_OPTIONS), core.ɵɵinject(common.DOCUMENT)); }, token: NgxHotkeysService, providedIn: "root" });
        NgxHotkeysService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(1, core.Inject(HOTKEY_OPTIONS)),
            __param(2, core.Inject(common.DOCUMENT)),
            __metadata("design:paramtypes", [platformBrowser.EventManager, Object, Object])
        ], NgxHotkeysService);
        return NgxHotkeysService;
    }());

    var NgxCheatsheetComponent = /** @class */ (function () {
        function NgxCheatsheetComponent(hotkeysService) {
            this.hotkeysService = hotkeysService;
            this.helpVisible = false;
            this._map = {
                meta: '\u2318',
                shift: '\u21E7',
                left: '\u2190',
                right: '\u2192',
                up: '\u2191',
                down: '\u2193',
                'return': '\u23CE',
                backspace: '\u232B' // ⌫
            };
            this.title = this.hotkeysService.options.cheatSheetTitle || this.title;
        }
        NgxCheatsheetComponent.prototype.ngOnInit = function () {
            var _this = this;
            this._subscription = this.hotkeysService.cheatSheetToggled
                .subscribe(function (isOpen) {
                if (isOpen !== false) {
                    _this.hotkeys = _this.hotkeysService.hotkeys
                        .filter(function (hotkey) { return hotkey.description; });
                }
                if (isOpen === false) {
                    _this.helpVisible = false;
                }
                else {
                    _this.toggleCheatSheet();
                }
            });
        };
        NgxCheatsheetComponent.prototype.formatHotkey = function (hotkey) {
            var combo = Array.isArray(hotkey.combo) ? hotkey.combo[0] : hotkey.combo;
            var sequence = combo.split(/[\s]/);
            for (var i = 0; i < sequence.length; i++) {
                sequence[i] = this.symbolize(sequence[i]);
            }
            return sequence;
        };
        NgxCheatsheetComponent.prototype.symbolize = function (combo) {
            var comboSplit = combo.split('.');
            for (var i = 0; i < comboSplit.length; i++) {
                // try to resolve command / ctrl based on OS:
                if (comboSplit[i] === 'mod') {
                    if (window.navigator && window.navigator.platform.indexOf('Mac') >= 0) {
                        comboSplit[i] = 'meta';
                    }
                    else {
                        comboSplit[i] = 'ctrl';
                    }
                }
                comboSplit[i] = this._map[comboSplit[i]] || comboSplit[i];
            }
            return comboSplit.join(' + ');
        };
        NgxCheatsheetComponent.prototype.ngOnDestroy = function () {
            if (this._subscription && !this._subscription.closed) {
                this._subscription.unsubscribe();
            }
        };
        NgxCheatsheetComponent.prototype.toggleCheatSheet = function () {
            this.helpVisible = !this.helpVisible;
        };
        NgxCheatsheetComponent.ctorParameters = function () { return [
            { type: NgxHotkeysService }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], NgxCheatsheetComponent.prototype, "title", void 0);
        NgxCheatsheetComponent = __decorate([
            core.Component({
                selector: 'ngx-cheatsheet',
                template: "<div class=\"ngx-cheatsheet fade\" [ngClass]=\"{'in': helpVisible}\" style=\"display:none\">\n  <div class=\"ngx-cheatsheet__hotkeys\">\n    <h4 class=\"ngx-cheatsheet__hotkeys__title\">{{ title }}</h4>\n    <table>\n      <tbody>\n        <tr *ngFor=\"let hotkey of hotkeys\">\n          <td class=\"ngx-cheatsheet__hotkeys__keys\">\n            <span class=\"ngx-cheatsheet__hotkeys__keys__key\">{{ formatHotkey(hotkey) }}</span>\n          </td>\n          <td class=\"ngx-cheatsheet__hotkeys__keys__text\">{{ hotkey.description }}</td>\n        </tr>\n      </tbody>\n    </table>\n    <div class=\"ngx-cheatsheet__hotkeys__close\" (click)=\"toggleCheatSheet()\">&#215;</div>\n  </div>\n</div>",
                styles: [".ngx-cheatsheet{display:table!important;position:fixed;width:100%;height:100%;top:0;left:0;color:#333;font-size:1em;background-color:rgba(255,255,255,.9)}.ngx-cheatsheet.fade{z-index:-1024;visibility:hidden;opacity:0;transition:opacity .15s linear}.ngx-cheatsheet.fade.in{z-index:10002;visibility:visible;opacity:1}.ngx-cheatsheet__hotkeys{width:100%;height:100%;display:table-cell;vertical-align:middle}.ngx-cheatsheet__hotkeys__title{font-weight:700;text-align:center;font-size:1.2em}.ngx-cheatsheet__hotkeys table{margin:auto;color:#333}.ngx-cheatsheet__hotkeys__keys{padding:5px;text-align:right}.ngx-cheatsheet__hotkeys__keys__key{display:inline-block;color:#fff;background-color:#333;border:1px solid #333;border-radius:5px;text-align:center;margin-right:5px;box-shadow:inset 0 1px 0 #666,0 1px 0 #bbb;padding:5px 9px;font-size:1em}.ngx-cheatsheet__hotkeys__keys__text{padding-left:10px;font-size:1em}.ngx-cheatsheet__hotkeys__close{position:fixed;top:20px;right:20px;font-size:2em;font-weight:700;padding:5px 10px;border:1px solid #ddd;border-radius:5px;min-height:45px;min-width:45px;text-align:center;cursor:pointer}@media all and (max-width:500px){.ngx-cheatsheet__hotkeys{font-size:.8em}}@media all and (min-width:750px){.ngx-cheatsheet__hotkeys{font-size:1.2em}}"]
            }),
            __metadata("design:paramtypes", [NgxHotkeysService])
        ], NgxCheatsheetComponent);
        return NgxCheatsheetComponent;
    }());

    var NgxHotkeysModule = /** @class */ (function () {
        function NgxHotkeysModule() {
        }
        NgxHotkeysModule_1 = NgxHotkeysModule;
        NgxHotkeysModule.forRoot = function (options) {
            return {
                ngModule: NgxHotkeysModule_1,
                providers: [
                    NgxHotkeysService,
                    {
                        provide: HOTKEY_OPTIONS,
                        useValue: options
                    }
                ]
            };
        };
        var NgxHotkeysModule_1;
        NgxHotkeysModule = NgxHotkeysModule_1 = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule
                ],
                declarations: [
                    NgxCheatsheetComponent
                ],
                exports: [
                    NgxCheatsheetComponent
                ]
            })
        ], NgxHotkeysModule);
        return NgxHotkeysModule;
    }());

    exports.NgxCheatsheetComponent = NgxCheatsheetComponent;
    exports.NgxHotkeysModule = NgxHotkeysModule;
    exports.NgxHotkeysService = NgxHotkeysService;
    exports.ɵa = HOTKEY_OPTIONS;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-hotkeys-vnc.umd.js.map
