import { OnDestroy, OnInit } from '@angular/core';
import { NgxHotkeysService } from '../services/ngx-hotkeys.service';
import { Hotkey } from '../interfaces';
import * as i0 from "@angular/core";
export declare class NgxCheatsheetComponent implements OnInit, OnDestroy {
    private hotkeysService;
    title: string;
    helpVisible: boolean;
    hotkeys: Hotkey[];
    private _subscription;
    private _map;
    constructor(hotkeysService: NgxHotkeysService);
    ngOnInit(): void;
    formatHotkey(hotkey: Hotkey): string[];
    private symbolize;
    ngOnDestroy(): void;
    toggleCheatSheet(): void;
    static ɵfac: i0.ɵɵFactoryDef<NgxCheatsheetComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<NgxCheatsheetComponent, "ngx-cheatsheet", never, { "title": "title"; }, {}, never, never>;
}
